{
 *  IRCDelphi - an Internet Relay Chat Daemon, PRJUPrincipal.pas
 *
 *  Copyright (C) 2001-2003 by the past and present ircd coders, and others.
 *  Refer to the documentation within doc/ for full credits and copyrights.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 *  USA
 *
}

unit PRJUPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, irc_const, Menus, IdThreadMgr, IdThreadMgrDefault,
  IdBaseComponent, IdComponent, IdTCPServer, IdIrcServer, ExtCtrls,
  ComCtrls, StdCtrls, idGlobal, IdSocks, IdIPWatch, WinSock, DateUtils;

//SecondsBetween

type
  TClient = class(TObject)
    Away,
    IP          : String;
    UserName    : String[USERLEN+1];
    Host,
    Server,
    Name        : String[NICKLEN+1];
    Info        : String[REALLEN+1];
    Port,
    UserCommand,
    NickCommand : Integer;
    Thread      : Pointer;
    LogonTime,
    LogonDate   : TDateTime;
  end;

  TChannel = class(TObject)
    Topic       : String[TOPICLEN+1];
    TopicNick   : String[NICKLEN+1];
    Name        : String[NICKLEN+1];
    CreationTime,
    TopicTime,
    CreationDate,
    TopicDate   : TDateTime;
  end;

  TMode = class(TObject)
    ChPtr,
    CPtr        : TObject;
    Mode        : String[1];
    Limit       : Integer;
    Key         : String[KEYLEN+1];
  end;

  TBan = class(TObject)
    ChPtr       : TObject;
    BanStr,
    Who         : String;
    DateStamp,
    TimeStamp   : TDateTime;
  end;

  TInvite = class(TObject)
    ChPtr,
    CPtr        : TObject;
  end;

  TChannelData = class(TObject)
    Flags       : String[3];
    ChPtr,
    CPtr        : TObject;
  end;

  TPRJFPrincipal = class(TForm)
    ircd: TIdIRCServer;
    ThreadMgrIRCD: TIdThreadMgrDefault;
    MMPrincipal: TMainMenu;
    Principal1: TMenuItem;
    OPTAtivar: TMenuItem;
    StatusBar1: TStatusBar;
    Ajuda1: TMenuItem;
    REStatus: TRichEdit;
    MConsoleEnter: TMemo;
    Config1: TMenuItem;
    ircdconf1: TMenuItem;
    ircdmotd1: TMenuItem;
    GUI1: TMenuItem;
    Manual1: TMenuItem;
    asdsd1: TMenuItem;
    procedure OPTAtivarClick(Sender: TObject);
    procedure Ajuda1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ircdCommandNick(Thread: TIdPeerThread; Parm1, Parm2: String);
    procedure GUI1Click(Sender: TObject);
    procedure Manual1Click(Sender: TObject);
    procedure ircdCommandOther(Thread: TIdPeerThread; Command,
      Parm: String);
    procedure ircdConnect(AThread: TIdPeerThread);
    procedure ircdCommandLusers(Thread: TIdPeerThread; Parm: String);
    procedure ircdCommandQuit(Thread: TIdPeerThread; Parm: String);
    procedure ircdCommandUser(Thread: TIdPeerThread; UserName, HostName,
      ServerName, RealName: String);
    procedure ircdCommandUserHost(Thread: TIdPeerThread; Parm: String);
    procedure ircdDisconnect(AThread: TIdPeerThread);
    procedure ircdCommandIsOn(Thread: TIdPeerThread; Parm: String);
    procedure ircdCommandPrivMsg(Thread: TIdPeerThread; Parm1,
      Parm2: String);
    procedure ircdCommandVersion(Thread: TIdPeerThread; Parm: String);
    procedure ircdCommandWhoIs(Thread: TIdPeerThread; Parm1,
      Parm2: String);
    procedure ircdCommandAway(Thread: TIdPeerThread; Parm: String);
    procedure ircdCommandJoin(Thread: TIdPeerThread; Parm1, Parm2: String);
    procedure ircdCommandNames(Thread: TIdPeerThread; Parm: String);
    procedure ircdCommandPart(Thread: TIdPeerThread; Parm: String);
    procedure ircdCommandList(Thread: TIdPeerThread; Parm1, Parm2: String);
    procedure ircdCommandMode(Thread: TIdPeerThread; Parm1, Parm2, Parm3,
      Parm4, Parm5: String);
    procedure ircdCommandPing(Thread: TIdPeerThread; Parm1, Parm2: String);
    procedure ircdCommandNotice(Thread: TIdPeerThread; Parm1,
      Parm2: String);
    procedure ircdException(AThread: TIdPeerThread; AException: Exception);
    procedure ircdCommandTopic(Thread: TIdPeerThread; Parm1,
      Parm2: String);
    procedure ircdCommandInvite(Thread: TIdPeerThread; Parm1,
      Parm2: String);
    procedure ircdCommandKick(Thread: TIdPeerThread; Parm1, Parm2,
      Parm3: String);

  private
    { Private declarations }
  public
    { Public declarations }
    ClientList,
    ModeList,
    BanList,
    ChannelList,
    ChannelDataList,
    InviteList  : TList;

    function IsRegistered(Thread: TIdPeerThread): Boolean;
    procedure RegisterUser(Thread: TIdPeerThread; UserName,  RealName, Nick: String);
    procedure ShowInfo(info: string);
    procedure WriteCl(Thread: TIdPeerThread; Text: AnsiString);
    procedure NotRegistered(Thread: TidPeerThread);
    function FindUser(Name: String): TObject;
    function FindChannel(Name: String): TObject;
    procedure SendToCommomChannels(Thread: TIdPeerThread; Text: String);
    function InvalidChars(Text: String; Nick: Integer): Boolean;
    procedure PrivNotice(Thread: TIdPeerThread; PrivNotice, Parm1,
       Parm2: String);
    function IsOnChannel(CPtr: TClient; ChPtr: TChannel): Boolean;
    function HaveMode(ChPtr: TChannel; Mode: String): TObject;
    function HaveUMode(CPtr: TClient; Mode: String): TObject;
    function FindClient(Name: String): TObject;
    function LookupHostName(const ipaddr: string): String;
    function IsOp(CPtr: TClient; ChPtr: TChannel): Boolean;
    function IsVoice(CPtr: TClient; ChPtr: TChannel): Boolean;
    procedure SendToChannel(ChPtr : TChannel; Text : String);
    function ValidMode(Mode : String): Boolean;
    function ValidUMode(Mode : String): Boolean;
    function FindChannelData(ChPtr: TChannel; ACPtr: TClient): Pointer;
    function Matches(const ABC, AX: String): Boolean;
    function FindInvite(ChPtr: TChannel; CPtr: TClient): Pointer;
    function FindBan(ChPtr: TChannel; MaskOn: Boolean; BanStr: String): Pointer;
    procedure FreeChan(ChPtr: TChannel);

  end;


var
  PRJFPrincipal: TPRJFPrincipal;
  Hora: string;
  LocalClientsCount,
  GlobalClientsCount,
  ChannelsCount: integer;

const
   me = nil;
   KnownCommands:Array [1..3] of string=
      (
       'LUSERS',    {Do not Localize}
       'KLINE',     {Do not Localize}
       'QLINE'      {Do not Localize}
      );
  Chars: Array [1..45] of string =
  ('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F','G',
   'H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','X','Z',
   'W','Y','','^','\','[',']','{','}','-','_');


implementation

uses PRJUIrcdConfGUI, PRJUIrcdConfManual;

{$R *.dfm}

function TPRJFPrincipal.Matches(const ABC, AX: String): Boolean;
var
  axNext,
  nextval     : Array of Integer;
  AbcLen,
  AxLen,
  AbcI,
  AxI,
  AxWWW,
  AxStar      :integer;
begin
  Result := True;
  abclen := Length(abc);
  axlen := Length(ax) ;
  SetLength(axnext, axlen + 1);
  SetLength(nextval, axlen + 1);
  abci := 1;
  axi := 1;
  axstar := 0;
  axwww := 0;
  axnext[1] := 0;
  nextval[1] := 0;
  while ((abci <= abclen) and (axi <= axlen)) do
  begin
    while (axi < AXLEN) do
    begin
      if ax[axi] = '*' then
      begin
        nextval[axi+1] := axi;
        axnext[axi+1] := axi;
        axwww:=axi;
        break;
      end;

      if (ax[axwww] = '*') or (ax[axi] = ax[axwww]) or (ax[axwww] = '?') or (axwww = 0) then
      begin
        axwww := axwww+1;
        axnext[axi+1] := axwww;
        if ax[axi+1] <> ax[axwww] then
          nextval[axi+1] := axwww
        else
          nextval[axi+1] := nextval[axwww];
        Break;
      end else
        axwww := nextval[axwww];

    end;
    if (ax[axi] = '*') then
    begin
      axstar := axi;
      axi := axi+1;
      Continue;
    end;

    if (ax[axi] = '?') then
    begin
      abci := abci+1;
      axi := axi+1;
      Continue;
    end;

    if (ax[axi] = abc[abci]) then
    begin
      Inc(abci);
      Inc(axi);
      Continue;
    end;

    if (ax[axi] <> abc[abci]) then
    begin
      axi := axnext[axi];

      if axi = 0 then
        axwww := 0
      else
        axwww := axnext[axi];

      if (axi = axstar) and (axstar >= 1) then
      begin
        Inc(abci);
        Continue;
      end;

      if (axi = axstar) and (axstar = 0) then
      begin
        Result := False;
        Break;
      end;
    end;
  end;

  if (Result = True) and (abci > abclen) and (axi <= axlen) and not ((ax[axlen] = '*') and (axlen = axi)) then
    Result := False;
  if (result = true) and (abci <= abclen) and (axi > axlen) and (ax[axlen] <> '*') then
    Result := False;

end;

procedure TPRJFPrincipal.NotRegistered(Thread: TidPeerThread);
begin
  WriteCl(Thread, Format('%d * userhost %s', [ERR_NOTREGISTERED, MSG_NOTREGISTERED]));
end;

function TPRJFPrincipal.IsRegistered(Thread: TIdPeerThread): Boolean;
var
  CPtr : TClient;
begin
  CPtr := Pointer(Thread.Data);
  if ((CPtr.NickCommand = 1) and (CPtr.UserCommand = 1)) then Result := True
  else Result := False;
end;

procedure TPRJFPrincipal.ShowInfo(Info: string);
var
  Times: string;
begin
  Times := TimeToStr(Time);
  PRJFPrincipal.REStatus.Lines.Add(Format(STS_INFO, [Times, Info]));
end;

function TPRJFPrincipal.FindChannel(Name: String): TObject;
var
  Count : Integer;
  ChPtr : TChannel;
begin
  ChPtr := nil;

  for Count := 0 to ChannelList.Count - 1 do
    if UpperCase(TChannel(ChannelList.Items[Count]).Name) = UpperCase(Name) then
      ChPtr := TChannel(ChannelList.Items[Count]);

  Result := ChPtr;
end;

function TPRJFPrincipal.FindUser(Name: String): TObject;
var
  Count : Integer;
  CPtr : TClient;
begin
  CPtr := nil;

  for Count := 0 to ClientList.Count - 1 do
    if UpperCase(TClient(ClientList.Items[Count]).Name) = UpperCase(Name) then
      CPtr := TClient(ClientList.Items[Count]);

  Result := CPtr;
end;


procedure TPRJFPrincipal.SendToCommomChannels(Thread: TIdPeerThread; Text: String);
var
  CPtr,
  ACPtr          : TClient;
  Count          : Integer;
  AThread       : TIdPeerThread;

  function HaveCommomChannel(ACPtr, CPtr: TClient): Boolean;
  var
    Count,
    Count2: Integer;
    XCPtr,
    XACptr : TClient;
    XChanPtr,
    XAChanPtr : TChannel;
  begin

    for Count := 0 to ChannelDataList.Count - 1 do
    begin
      XACPtr := Pointer(TChannelData(ChannelDataList.Items[Count]).CPtr) ;
      if XACptr <> ACPtr then
        Continue;

      for Count2 := 0 to ChannelDataList.Count - 1 do
      begin
        XCPtr := Pointer(TChannelData(ChannelDataList.Items[Count2]).CPtr);
        if XCPtr <> CPtr then
          Continue;

        XChanPtr := Pointer(TChannelData(ChannelDataList.Items[Count]).ChPtr);
        XAChanPtr := Pointer(TChannelData(ChannelDataList.Items[Count2]).ChPtr);
        if XChanPtr = XAChanPtr then
        begin
          Result := True;
          Exit;
        end;
      end;
    end;
    Result := False;

  end;

begin
  CPtr := Pointer(Thread.Data);

  for Count := 0 to ClientList.Count - 1 do
  begin
    ACPtr := TClient(ClientList.Items[Count]);
    if ACPtr = CPtr then begin
      Continue;
    end;

    if HaveCommomChannel(ACPtr, CPtr) then
    begin
      AThread := ACPtr.Thread;
      AThread.Connection.WriteLn(Text);
    end;
  end;

end;

function TPRJFPrincipal.InvalidChars(Text: String; Nick: Integer): Boolean;
var
  Count,
  CountText: Integer;
  Ok : Boolean;
begin
  Text := UpperCase(Text);

  Ok := False;

  for CountText := 1 to Length(Text) do
  begin
    for Count := 1 to 45 do
    begin
      if ((CountText = 1) and (Count < 11)) then
        if Chars[Count] = Copy(Text,1,1) then
        begin
          Ok := False;
          Break;
        end;

      if Chars[Count] = Copy(Text,CountText,1) then
      begin
        Ok := True;
        Break;
      end;
    end;

    if Ok = False then
      Break
    else
      if CountText = Length(Text) then
      begin
        Ok := True;
        Break;
      end else
        Ok := False;

  end;

  if Ok = False then
    Result := True
  else
    Result := False;

end;

function TPRJFPrincipal.IsOnChannel(CPtr: TClient; ChPtr: TChannel): Boolean;
var
  Count : Integer;
  ChDataPtr,
  AChDataPtr : TChannelData;
begin
  AChDataPtr := nil;
  for Count := 0 to ChannelDataList.Count - 1 do
  begin
    ChDataPtr := Pointer(TChannelData(ChannelDataList.Items[Count]));
    if (CPtr = Pointer(ChDataPtr.CPtr)) and (ChPtr = Pointer(ChDataPtr.ChPtr)) then
      AChDataPtr := ChDataPtr;
  end;

  if AChDataPtr = nil then
    Result := False
  else
    Result := True;

end;

function TPRJFPrincipal.HaveMode(ChPtr: TChannel; Mode: String): TObject;
var
  Count : Integer;
  ModePtr,
  AModePtr : TMode;
begin
  AModePtr := nil;
  for Count := 0 to ModeList.Count - 1 do
  begin
    ModePtr := Pointer(TMode(ModeList.Items[Count]));
    if (ChPtr = Pointer(ModePtr.ChPtr)) and (Mode = ModePtr.Mode) then
      AModePtr := Pointer(ModePtr);
  end;

  Result := AModePtr;

end;

function TPRJFPrincipal.HaveUMode(CPtr: TClient; Mode: String): TObject;
var
  Count : Integer;
  ModePtr,
  AModePtr : TMode;
begin
  AModePtr := nil;
  for Count := 0 to ModeList.Count - 1 do
  begin
    ModePtr := Pointer(TMode(ModeList.Items[Count]));
    if (CPtr = Pointer(ModePtr.CPtr)) and (Mode = ModePtr.Mode) then
      AModePtr := Pointer(ModePtr);
  end;

  Result := AModePtr;

end;

function TPRJFPrincipal.IsOp(CPtr: TClient; ChPtr: TChannel): Boolean;
var
  Count : Integer;
  ChDataPtr,
  AChDataPtr : TChannelData;
begin
  AChDataPtr := nil;
  for Count := 0 to ChannelDataList.Count - 1 do
  begin
    ChDataPtr := Pointer(TChannelData(ChannelDataList.Items[Count]));
    if ((CPtr = Pointer(ChDataPtr.CPtr)) and (ChPtr = Pointer(ChDataPtr.ChPtr))) and (Pos('o',ChDataPtr.Flags) <> 0 ) then
      AChDataPtr := ChDataPtr;
  end;

  if AChDataPtr = nil then
    Result := False
  else
    Result := True;

end;

function TPRJFPrincipal.IsVoice(CPtr: TClient; ChPtr: TChannel): Boolean;
var
  Count : Integer;
  ChDataPtr,
  AChDataPtr : TChannelData;
begin
  AChDataPtr := nil;
  for Count := 0 to ChannelDataList.Count - 1 do
  begin
    ChDataPtr := Pointer(TChannelData(ChannelDataList.Items[Count]));
    if ((CPtr = Pointer(ChDataPtr.CPtr)) and (ChPtr = Pointer(ChDataPtr.ChPtr))) and (Pos('v',ChDataPtr.Flags) <> 0 ) then
      AChDataPtr := ChDataPtr;
  end;

  if AChDataPtr = nil then
    Result := False
  else
    Result := True;

end;

function TPRJFPrincipal.FindClient(Name: String): TObject;
var
  Count : Integer;
  CPtr : TClient;
begin
  CPtr := nil;

  for Count := 0 to ClientList.Count - 1 do
    if UpperCase(TClient(ClientList.Items[Count]).Name) = UpperCase(Name) then
      CPtr := TClient(ClientList.Items[Count]);

  Result := CPtr;

end;

procedure TPRJFPrincipal.FreeChan(ChPtr: TChannel);
var
  InvPtr : TInvite;
  ModePtr : TMode;
  BanPtr  : TBan;
  Count   : Integer;

label InviteFree, ModeFree, BanFree;
begin
    InviteFree:
    for Count := 0 to InviteList.Count - 1 do
      if (ChPtr = Pointer(TInvite(InviteList.Items[Count]).ChPtr)) then
      begin
        InvPtr := Pointer(TInvite(InviteList.Items[Count]));
        InviteList.Delete(InviteList.IndexOf(InvPtr));
        InvPtr.Free;
        goto InviteFree;
      end;
    BanFree:
    for Count := 0 to BanList.Count - 1 do
      if (ChPtr = Pointer(TBan(BanList.Items[Count]).ChPtr)) then
      begin
        BanPtr := Pointer(TBan(BanList.Items[Count]));
        BanList.Delete(BanList.IndexOf(BanPtr));
        BanPtr.Free;
        goto BanFree;
      end;

    ModeFree:
    for Count := 0 to ModeList.Count - 1 do
      if (ChPtr = Pointer(TMode(ModeList.Items[Count]).ChPtr)) then
      begin
        ModePtr := Pointer(TMode(ModeList.Items[Count]));
        ModeList.Delete(ModeList.IndexOf(ModePtr));
        ModePtr.Free;
        goto ModeFree;
      end;
end;

function TPRJFPrincipal.FindChannelData(ChPtr: TChannel; ACPtr: TClient): Pointer;
var
  Count : Integer;
  ChDataPtr : TChannelData;
begin
  ChDataPtr := nil;

  for Count := 0 to ChannelDataList.Count - 1 do
    if (ChPtr = Pointer(TChannelData(ChannelDataList.Items[Count]).ChPtr)) and (ACPtr = Pointer(TChannelData(ChannelDataList.Items[Count]).CPtr)) then
      ChDataPtr := Pointer(TChannelData(ChannelDataList.Items[Count]));

  Result := ChDataPtr;

end;

function TPRJFPrincipal.FindInvite(ChPtr: TChannel; CPtr: TClient): Pointer;
var
  Count : Integer;
  InvPtr,
  AInvPtr : TInvite;
begin
  AInvPtr := nil;

  for Count := 0 to InviteList.Count - 1 do
  begin
    InvPtr := Pointer(TInvite(InviteList.Items[Count]));
    if (ChPtr = Pointer(InvPtr.ChPtr)) and (CPtr = Pointer(InvPtr.CPtr)) then
      AInvPtr := Pointer(InvPtr);
  end;

  Result := Pointer(AInvPtr);

end;

function TPRJFPrincipal.FindBan(ChPtr: TChannel; MaskOn: Boolean; BanStr: String): Pointer;
var
  Count : Integer;
  ABanPtr,
  BanPtr : TBan;
begin
  ABanPtr := nil;

  for Count := 0 to BanList.Count - 1 do
  begin
    BanPtr := Pointer(TBan(BanList.Items[Count]));
    if (MaskOn = True) then
    begin
      if (ChPtr = Pointer(BanPtr.ChPtr)) and (Matches(BanStr, BanPtr.BanStr)) then
        ABanPtr := Pointer(BanPtr)
    end else
    begin
      if (ChPtr = Pointer(BanPtr.ChPtr)) and (BanStr = BanPtr.BanStr) then
        ABanPtr := Pointer(BanPtr);
    end;
  end;

  Result := Pointer(ABanPtr);

end;


function TPRJFPrincipal.ValidMode(Mode : String): Boolean;
var
  Count : Integer;
  AMode : String;
begin

  AMode := '';

  for Count := 1 to 11 do
    if Mode = chan_modes[Count] then
      AMode := Mode;

  if AMode = '' then
    Result := False
  else
    Result := True;

end;

function TPRJFPrincipal.ValidUMode(Mode : String): Boolean;
var
  Count : Integer;
  AMode : String;
begin

  AMode := '';

  for Count := 1 to 11 do
    if Mode = user_modes[Count] then
      AMode := Mode;

  if AMode = '' then
    Result := False
  else
    Result := True;

end;

//LookupHostName

function TPRJFPrincipal.LookupHostName(const ipaddr: string): String;
var
  h: PHostEnt;
  addr: TSockAddr;
begin
  Result := '';
  addr.sin_addr.s_addr := inet_addr(pchar(ipaddr));
  if addr.sin_addr.s_addr <> INADDR_NONE then
  begin
    h := gethostbyaddr(@addr.sin_addr.s_addr, sizeof(addr), AF_INET);
    if h <> nil then
      Result := h^.h_name;
  end;
end;

procedure TPRJFPrincipal.SendToChannel(ChPtr : TChannel; Text : String);
var
  ChDataPtr : TChannelData;
  Count     : Integer;
  Thread    : TIdPeerThread;
  CPtr      : TClient;
begin
  for Count := 0 to ChannelDataList.Count - 1 do
  begin
    ChDataPtr := Pointer(TChannelData(ChannelDataList.Items[Count]));
    if (ChPtr = Pointer(ChDataPtr.ChPtr)) then
    begin
      CPtr := Pointer(ChDataPtr.CPtr);
      Thread := CPtr.Thread;
      Thread.Connection.WriteLn(Text);
    end;

  end;
end;

procedure TPRJFPrincipal.PrivNotice(Thread: TIdPeerThread; PrivNotice, Parm1,
  Parm2: String);
// Parm1 = destino
// Parm2 = mensagem
var
  CPtr,
  ACPtr         : TClient;
  Count         : Integer;
  AThread       : TIdPeerThread;
  ChPtr,
  AChPtr        : TChannel;
begin
  if not IsRegistered(Thread) then
  begin
    NotRegistered(Thread);
    exit;
  end;

  CPtr := Pointer(Thread.Data);

  if (Length(Parm2) < 1) then begin
    WriteCl(Thread, Format('%d %s %s', [CPtr.Name, ERR_NOTEXTTOSEND, MSG_NOTEXTTOSEND]));
    Exit;
  end;

  if (Copy(Parm1,0,1) <> '#') then
  begin

    ACPtr := Pointer(FindClient(Parm1));

    If ACPtr <> nil then
    begin
      AThread := ACPtr.Thread;
      AThread.Connection.WriteLn(Format(':%s!%s@%s %s %s %s', [CPtr.Name, CPtr.UserName, CPtr.Host, PrivNotice, ACPtr.Name, Parm2]));
    end else
      WriteCl(Thread, Format('%d %s %s', [ERR_NOSUCHNICK, CPtr.Name, Format(MSG_NOSUCHNICK, [Parm1]) ]));
  end else
  begin

    if (FindChannel(Parm1) <> nil) then
    begin
      ChPtr := Pointer(FindChannel(Parm1));

      if HaveMode(ChPtr, 'n') <> nil then
        if not IsOnChannel(CPtr, ChPtr) then
        begin
          WriteCl(Thread, Format('%d %s %s', [ERR_CANNOTSENDTOCHAN, CPtr.Name, Format(MSG_CANNOTSENDTOCHAN, [Parm1])]));
          Exit;
        end;

      if (HaveMode(ChPtr, 'm') <> nil) and (not IsOp(CPtr, ChPtr)) and (not IsVoice(CPtr, ChPtr)) then
      begin
        WriteCl(Thread, Format('%d %s %s', [ERR_CANNOTSENDTOCHAN, CPtr.Name, Format(MSG_CANNOTSENDTOCHAN, [Parm1])]));
        Exit;
      end;

      for Count := 0 to ChannelDataList.Count - 1 do
      begin
         AChPtr := Pointer(TChannelData(ChannelDataList.Items[Count]).ChPtr);
         if AChPtr = ChPtr then
         begin
           ACPtr := Pointer(TChannelData(ChannelDataList.Items[Count]).CPtr);
           if UpperCase(CPtr.Name) <> UpperCase(ACPtr.Name) then
           begin
             AThread := ACPtr.Thread;
             AThread.Connection.WriteLn(Format(':%s!%s@%s %s %s %s', [CPtr.Name, CPtr.UserName, CPtr.Host, PrivNotice, Parm1, Parm2]));
           end;
         end;
      end;
    end else
      WriteCl(Thread, Format('%d %s %s', [ERR_NOSUCHNICK, CPtr.Name, Format(MSG_NOSUCHNICK, [Parm1]) ]));

  end;

end;

procedure TPRJFPrincipal.FormCreate(Sender: TObject);
begin
  PRJFPrincipal.Caption := Format('%s - %s', [STS_VERSION, MENAME]);
  Application.Title := PRJFPrincipal.Caption;

  ShowInfo('http://www.ircdelphi.rg3.net');
  ShowInfo(STS_VERSION);
  ShowInfo('Creating lists...');
  ClientList := TList.Create;
  ModeList := TList.Create;
  BanList := TList.Create;
  ChannelList := TList.Create;
  ChannelDataList := TList.Create;
  InviteList := TList.Create;
  ShowInfo('Ok, ircd loaded but not started');
end;

procedure TPRJFPrincipal.ircdConnect(AThread: TIdPeerThread);
var
  CPtr : TClient;
  Host : String;
begin
  CPtr := TClient.Create;
  CPtr.Host := AThread.Connection.Socket.Binding.PeerIP;
  CPtr.IP := AThread.Connection.Socket.Binding.PeerIP;
  CPtr.Port := AThread.Connection.Socket.Binding.PeerPort;
  CPtr.Thread := AThread;
  CPtr.LogonTime := Time;
  CPtr.LogonDate := Date;
  AThread.Data := CPtr;
  ClientList.Add(CPtr);
  AThread.Connection.WriteLn(BREPORT_DO_DNS);;
  Host := LookupHostName(AThread.Connection.Socket.Binding.PeerIP);
  if Host = '' then
    AThread.Connection.WriteLn(BREPORT_FAIL_DNS)
  else begin
    AThread.Connection.WriteLn(BREPORT_FIN_DNS);
    CPtr.Host := Host;
  end;
end;

procedure TPRJFPrincipal.ircdDisconnect(AThread: TIdPeerThread);
var
  CPtr,
  ACptr : TClient;
  Count,
  Count2,
  TotalMembers : Integer;
  ChanDataPtr : TChannelData;
  ChanPtr,
  AChanPtr : TChannel;

  label ChannelDataFree;
begin
  CPtr := Pointer(AThread.Data);

  ChannelDataFree:
  for Count := 0 to ChannelDataList.Count - 1 do
  begin
    ACptr := Pointer(TChannelData(ChannelDataList.Items[Count]).CPtr);
    if ACptr = CPtr then
    begin
      TotalMembers := 0;
      ChanDataPtr := Pointer(TChannelData(ChannelDataList.Items[Count]));
      ChanPtr := Pointer(ChanDataPtr.ChPtr);
      for Count2 := 0 to ChannelDataList.Count - 1 do
      begin
        AChanPtr := Pointer(TChannelData(ChannelDataList.Items[Count2]).ChPtr);
        if ChanPtr = AChanPtr then
          Inc(TotalMembers);
      end;
      if TotalMembers = 1 then
      begin
        FreeChan(ChanPtr);

        ChannelList.Delete(ChannelList.IndexOf(ChanPtr));
        ChanPtr.Free;
        Dec(ChannelsCount);
      end;
      ChannelDataList.Delete(ChannelDataList.IndexOf(ChanDataPtr));
      ChanDataPtr.Free;
      goto ChannelDataFree;
    end;
  end;

  ClientList.Delete(ClientList.IndexOf(CPtr));
  CPtr.Free;
  AThread.Data := nil;
  Dec(LocalClientsCount);
  Dec(GlobalClientsCount);
end;

procedure TPRJFPrincipal.ircdCommandNick(Thread: TIdPeerThread; Parm1,
  Parm2: String);
var
  CPtr          : TClient;
  VerifyNick,
  Count         : Integer;
  NickTmp       : String;

begin
  CPtr := Pointer(Thread.Data);

  if (Pos(':',Parm1) <> 0) then
    Parm1 := Copy(Parm1,Pos(':',Parm1)+1,Length(Parm1));

  VerifyNick := 0;

  if InvalidChars(Parm1,1) then
  begin

    if CPtr.Name = '' then
      NickTmp := '*'
    else
      NickTmp := CPtr.Name;

    WriteCl(Thread, Format('%d %s %s', [ERR_ERRONEUSNICKNAME, NickTmp, Format(MSG_ERRONEUSNICKNAME, [Parm1])]));
    Exit;
  end;

  for Count := 0 to ClientList.Count - 1 do
    if UpperCase(TClient(ClientList.Items[Count]).Name) = UpperCase(Parm1) then
      VerifyNick := 1;

  if VerifyNick = 1 then
  begin
    WriteCl(Thread, Format('%d * %s', [ERR_NICKNAMEINUSE, Format(MSG_NICKNAMEINUSE, [Parm1])] ));
    Exit;
  end;

  if not IsRegistered(Thread) then
    RegisterUser(Thread, CPtr.UserName, CPtr.Info, Parm1)
  else
  begin
    Thread.Connection.WriteLn(Format(':%s!%s@%s NICK :%s', [CPtr.Name, CPtr.UserName, CPtr.Host, Copy(Parm1,0,NICKLEN)]));
    SendToCommomChannels(Thread, Format(':%s!%s@%s NICK :%s', [CPtr.Name, CPtr.UserName, CPTr.Host, Copy(Parm1,0,NICKLEN)]));
    CPtr.Name := Copy(Parm1,0,NICKLEN);
  end;

end;

procedure TPRJFPrincipal.ircdCommandUser(Thread: TIdPeerThread; UserName,
  HostName, ServerName, RealName: String);
var
  CPtr : TClient;
begin
  CPtr := Pointer(Thread.Data);

  if IsRegistered(Thread) = False then begin
    RegisterUser(Thread, UserName, RealName, CPtr.Name);
  end else begin
    if CPtr.Name <> '' then begin
      WriteCl(Thread, Format('%d %s %s', [ERR_ALREADYREGISTRED, CPtr.Name, MSG_ALREADYREGISTRED]));
    end;
  end;

end;

procedure TPRJFPrincipal.RegisterUser(Thread: TIdPeerThread; UserName, RealName, Nick: String);
var
  CPtr          : TClient;
  Count         : Integer;
  ChModes        : String;
begin

  CPtr := Pointer(Thread.Data);
  if ((CPtr.UserCommand <> 1) and (UserName <> '') and (RealName <> '')) then
  begin
    CPtr.UserName := '~'+UserName;
    CPtr.Info := Copy(RealName,2,Length(RealName));
    CPtr.UserCommand := 1;
    CPtr.Server := MENAME;
  end;

  if ((CPtr.NickCommand <> 1) and (Nick <> '')) then
  begin
    CPtr.Name := Nick;
    CPtr.NickCommand := 1;
  end;

  if ((CPtr.NickCommand = 1) and (CPtr.UserCommand = 1)) then
  begin
    Inc(LocalClientsCount);
    Inc(GlobalClientsCount);

    WriteCl(Thread, Format('001 %s :Welcome to this Great IRC Network '+#2+'%s!%s@%s'+#2, [CPtr.Name, CPtr.Name, CPtr.UserName, CPtr.Host]));
    WriteCl(Thread, Format('002 %s :Your host is %s, running version %s', [CPtr.Name, MENAME, STS_VERSION]));
    Thread.Connection.WriteLn(Format('NOTICE %s :*** Your host is %s, running version %s', [CPtr.Name, MENAME, STS_VERSION]));
    WriteCl(Thread, Format('003 %s :This server was created %s', [CPtr.Name, STS_DATECREATE]));
    WriteCl(Thread, Format('004 %s %s %s', [CPtr.Name, ircd.LocalName, STS_VERSION]));

    for Count := 1 to 11 do
      ChModes := ChModes+chan_modes[Count];

    WriteCl(Thread, Format('005 %s MAXBANS=%s NICKLEN=%s TOPICLEN=%s KICKLEN=%s CHANNELLEN=%s CHANTYPES=# CHANMODES=%s NETWORK=%s MAXCHANNELS=%s PREFIX=(%s)%s :is supported on this server', [CPtr.Name, IntToStr(MAXBANS), IntToStr(NICKLEN), IntToStr(TOPICLEN), IntToStr(KICKLEN), IntToStr(NICKLEN),{ChModes} 'b,k,limnpst', MENETWORK, IntToStr(MAXCHANNELS), 'ov', '@+']));

    ircdCommandLusers(Thread, '');

    WriteCl(Thread, Format('%d %s %s', [RPL_MOTDSTART, CPtr.Name, Format(MSG_MOTDSTART, [MENAME])]));
    WriteCl(Thread, Format('%d %s %s', [ERR_NOMOTD, CPtr.Name, MSG_NOMOTD]));
    WriteCl(Thread, Format('%d %s %s', [RPL_ENDOFMOTD, CPtr.Name, MSG_ENDOFMOTD]));
  end;

end;


procedure TPRJFPrincipal.ircdCommandLusers(Thread: TIdPeerThread; Parm: String);
var
  CPtr : TClient;
begin
  if not IsRegistered(Thread) then
  begin
    NotRegistered(Thread);
    exit;
  end;

  CPtr := Pointer(Thread.Data);

  WriteCl(Thread, Format('%d %s %s', [RPL_LUSERCLIENT, CPtr.Name, Format(MSG_LUSERCLIENT, [LocalClientsCount, 0, 1])]));
  WriteCl(Thread, Format('%d %s %s', [RPL_LUSEROP, CPtr.Name, Format(MSG_LUSEROP, [0])]));
  WriteCl(Thread, Format('%d %s %s', [RPL_LUSERUNKNOWN, CPtr.Name, Format(MSG_LUSERUNKNOWN, [0])]));
  WriteCl(Thread, Format('%d %s %s', [RPL_LUSERCHANNELS, CPtr.Name, Format(MSG_LUSERCHANNELS, [ChannelsCount])]));
  WriteCl(Thread, Format('%d %s %s', [RPL_LUSERME, CPtr.Name, Format(MSG_LUSERME, [LocalClientsCount, 0])]));
  WriteCl(Thread, Format('%d %s %s', [RPL_LUSERLOCALUSERS, CPtr.Name, Format(MSG_LUSERLOCALUSERS, [LocalClientsCount])]));
  WriteCl(Thread, Format('%d %s %s', [RPL_LUSERGLOBALUSERS, CPtr.Name, Format(MSG_LUSERGLOBALUSERS, [GlobalClientsCount])]));

end;

procedure TPRJFPrincipal.ircdCommandQuit(Thread: TIdPeerThread;
  Parm: String);
var
  CPtr : TClient;
begin
  if not IsRegistered(Thread) then
  begin
    NotRegistered(Thread);
    exit;
  end;

  CPtr := Pointer(Thread.Data);

  if Copy(Parm,1,1) = ':' then
    Parm := Copy(Parm,2,Length(Parm));

  SendToCommomChannels(Thread, Format(':%s!%s@%s QUIT :Quit: %s', [CPtr.Name, CPtr.UserName, CPtr.Host, Parm]));

  Thread.Connection.WriteLn('ERROR :Closing Link: ' + CPtr.Name + '[' + CPtr.UserName + '@'+ CPtr.Host +'] ('+Parm+')');
  Thread.Connection.DisconnectSocket;
end;

procedure TPRJFPrincipal.WriteCl(Thread: TIdPeerThread; Text: AnsiString);
begin
  Thread.Connection.WriteLn(Format(':%s %s', [MENAME, Text]));
end;

procedure TPRJFPrincipal.OPTAtivarClick(Sender: TObject);
begin
  if OPTAtivar.Checked = False then begin
    ShowInfo('Starting ircd...');
    ircd.Active := True;
    OPTAtivar.Checked := True;
    ShowInfo('Ircd started!');
    StatusBar1.SimpleText := 'Status: ircd started!'
  end else begin
    ShowInfo('Halting ircd...');
    ircd.Active := False;
    OPTAtivar.Checked := False;
    ShowInfo('Ircd halted :(');
    StatusBar1.SimpleText := 'Status: ircd halted :(';
  end;
end;

procedure TPRJFPrincipal.Ajuda1Click(Sender: TObject);
begin
  ShowMessage(Format('%s - %s',[STS_VERSION, 'Developed by Waldemar Christiano Becker Neto - Copyright (c) 2001-2003']));
end;

procedure TPRJFPrincipal.GUI1Click(Sender: TObject);
begin
  PRJFIrcdConfGUI.ShowModal;
end;

procedure TPRJFPrincipal.Manual1Click(Sender: TObject);
begin
  PRJFIrcdConfManual.ShowModal;
end;

procedure TPRJFPrincipal.ircdCommandOther(Thread: TIdPeerThread; Command,
  Parm: String);
// Command = Comando
// Parm = Parametros do comando
begin
  Case Succ ( PosInStrArray ( Uppercase ( Command ), KnownCommands ) ) of
    1 : {LUSERS}
       ircdCommandLusers(Thread, Parm);
  else
    ShowInfo('Not implemented. Command: '+Command+' Parm: '+Parm);
    WriteCl(Thread, Format('%d %s %s', [ERR_UNKNOWNCOMMAND, 'Nick', Format(MSG_UNKNOWNCOMMAND, [Command])]));
  end;
end;

procedure TPRJFPrincipal.ircdCommandUserHost(Thread: TIdPeerThread;
  Parm: String);
//Parm = nick
var
  CPtr, ACPtr : TClient;
  Count : Integer;
  ACPtrAway : String;
begin
  CPtr := Pointer(Thread.Data);
  if not IsRegistered(Thread) then begin NotRegistered(Thread); exit; end;

  ACPtr := nil;

  for Count := 0 to ClientList.Count - 1 do
    if UpperCase(TClient(ClientList.Items[Count]).Name) = UpperCase(Parm) then
      ACPtr := TClient(ClientList.Items[Count]);

  If ACPtr <> nil then begin
    if ACPtr.Away = '' then
      ACPtrAway := '+'
    else
      ACPtrAway := '-';
    WriteCl(Thread, Format('%d %s %s', [RPL_USERHOST, CPtr.Name, Format(MSG_USERHOST, [ACPtr.Name, ACPtrAway+ACPtr.UserName+'@'+ACPtr.Host] ) ]));
  end else
    WriteCl(Thread, Format('%d %s %s', [RPL_USERHOST, CPtr.Name, ':' ]));

end;

procedure TPRJFPrincipal.ircdCommandIsOn(Thread: TIdPeerThread;
  Parm: String);
// Parm = nick
var
  CPtr: TClient;
  Count,
  IsOn : Integer;
begin
  CPtr := Pointer(Thread.Data);
  if not IsRegistered(Thread) then begin NotRegistered(Thread); exit; end;

  IsOn := 0;

  for Count := 0 to ClientList.Count - 1 do
    if UpperCase(TClient(ClientList.Items[Count]).Name) = UpperCase(Parm) then
      IsOn := 1;

  If IsOn = 1 then
    WriteCl(Thread, Format('%d %s %s', [RPL_ISON, CPtr.Name, Format(MSG_ISON, [Parm])]))
  else
    WriteCl(Thread, Format('%d %s %s', [RPL_ISON, CPtr.Name, ':' ]));

end;

procedure TPRJFPrincipal.ircdCommandPrivMsg(Thread: TIdPeerThread; Parm1,
  Parm2: String);
begin
  PrivNotice(Thread, 'PRIVMSG', Parm1, Parm2);
end;

procedure TPRJFPrincipal.ircdCommandVersion(Thread: TIdPeerThread;
  Parm: String);
// Parm = outro servidor
var
  CPtr : TClient;
begin
  if not IsRegistered(Thread) then
  begin
    NotRegistered(Thread);
    exit;
  end;

  CPtr := Pointer(Thread.Data);
  WriteCl(Thread, Format('%d %s %s', [RPL_VERSION, CPtr.Name, Format(MSG_VERSION, [STS_VERSION, MENAME, ''])]));
end;

procedure TPRJFPrincipal.ircdCommandWhoIs(Thread: TIdPeerThread; Parm1,
  Parm2: String);
var
  CPtr, ACPtr   : TClient;
  Count         : Integer;
  TempChans,
  TempChan      : String;
  ChPtr         : TChannel;
  ChDataPtr     : TChannelData;
begin
  if not IsRegistered(Thread) then
  begin
    NotRegistered(Thread);
    exit;
  end;

  CPtr := Pointer(Thread.Data);

  ACPtr := nil;
  for Count := 0 to ClientList.Count - 1 do
    if UpperCase(TClient(ClientList.Items[Count]).Name) = UpperCase(Parm1) then
      ACPtr := TClient(ClientList.Items[Count]);

  If ACPtr <> nil then
  begin
    WriteCl(Thread, Format('%d %s %s', [RPL_WHOISUSER, CPtr.Name, Format(MSG_WHOISUSER, [ACPtr.Name, ACPtr.UserName, ACPtr.Host, ACPtr.Info])]));
    for Count := 0 to ChannelDataList.Count - 1 do
      if ACPtr = Pointer(TChannelData(ChannelDataList.Items[Count]).CPtr) then
      begin
        TempChan := '';
        ChPtr := Pointer(TChannelData(ChannelDataList.Items[Count]).ChPtr);
        ChDataPtr := Pointer(TChannelData(ChannelDataList.Items[Count]));
        if Pos('v',ChDataPtr.Flags) <> 0 then
          TempChan := '+';
        if Pos('o',ChDataPtr.Flags) <> 0 then
          TempChan := '@';

        TempChan := TempChan+ChPtr.Name;

        if TempChans = '' then
          TempChans := TempChan
        else
          TempChans := TempChans+' '+TempChan;
      end;

    if TempChans <> '' then
      WriteCl(Thread, Format('%d %s %s', [RPL_WHOISCHANNELS, CPtr.Name, Format(MSG_WHOISCHANNELS, [ACPtr.Name, TempChans])]));

    WriteCl(Thread, Format('%d %s %s', [RPL_WHOISSERVER, CPtr.Name, Format(MSG_WHOISSERVER, [ACPtr.Name, MENAME, MEDESCRIPTION])]));
    if ACPtr.Away <> '' then
      WriteCl(Thread, Format('%d %s %s', [RPL_AWAY, CPtr.Name, Format(MSG_AWAY, [ACPtr.Name, ACPtr.Away])]));
    WriteCl(Thread, Format('%d %s %s', [RPL_ENDOFWHOIS, CPtr.Name, Format(MSG_ENDOFWHOIS, [ACPtr.Name])]));
  end else
  begin
    WriteCl(Thread, Format('%d %s %s', [ERR_NOSUCHNICK, CPtr.Name, Format(MSG_NOSUCHNICK, [Parm1]) ]));
    WriteCl(Thread, Format('%d %s %s', [RPL_ENDOFWHOIS, CPtr.Name, Format(MSG_ENDOFWHOIS, [Parm1])]));
  end;

end;

procedure TPRJFPrincipal.ircdCommandAway(Thread: TIdPeerThread;
  Parm: String);
var
  CPtr: TClient;
begin
  if not IsRegistered(Thread) then
  begin
    NotRegistered(Thread);
    exit;
  end;

  CPtr := Pointer(Thread.Data);

  if (Length(Parm) > 1) then
  begin
    CPtr.Away := Copy(Parm,2,Length(Parm));
    WriteCl(Thread, Format('%d %s %s', [RPL_NOWAWAY, CPtr.Name, MSG_NOWAWAY]));
  end else
  begin
    CPtr.Away := '';
    WriteCl(Thread, Format('%d %s %s', [RPL_UNAWAY, CPtr.Name, MSG_UNAWAY]));
  end;

end;

procedure TPRJFPrincipal.ircdCommandJoin(Thread: TIdPeerThread; Parm1,
  Parm2: String);
var
  CPtr,
  ACPtr         : TClient;
  ChPtr,
  AChPtr        : TChannel;
  ChDataPtr     : TChannelData;
  AThread       : TIdPeerThread;
  Count,
  CountChans,
  CountTotal    : Integer;
  Channel,
  ChannelKey    : TStringList;
  ModePtr       : TMode;
  ModeTmp       : String;
begin
  if not IsRegistered(Thread) then
  begin
    NotRegistered(Thread);
    exit;
  end;

  CPtr := Pointer(Thread.Data);

  Channel := TStringList.Create;
  ChannelKey := TStringList.Create;

  Channel.CommaText := Parm1;
  ChannelKey.CommaText := Parm2;

  for CountChans := 0 to Channel.Count - 1 do
  begin
    if Copy(Channel[CountChans],1,1) = '#' then
    begin
      CountTotal := 0;
      for Count := 0 to ChannelDataList.Count - 1 do
        if (CPtr = Pointer(TChannelData(ChannelDataList.Items[Count]).CPtr)) then
          Inc(CountTotal);

      if (CountTotal = MAXCHANNELS) then
      begin
        WriteCl(Thread, Format('%d %s '+MSG_TOOMANYCHANNELS, [ERR_TOOMANYCHANNELS, CPtr.Name, Channel[CountChans]]));
        Exit;
      end;

      CountTotal := 0;

      if FindChannel(Channel[CountChans]) = nil then
      begin

        if InvalidChars(Copy(Channel[CountChans],2,Length(Channel[CountChans])),0) then
          Continue;

        ChPtr := TChannel.Create;
        ChPtr.Name := Channel[CountChans];
        ChPtr.CreationTime := Time;
        ChPtr.CreationDate := Date;
        ChannelList.Add(ChPtr);

        ModePtr := TMode.Create;
        ModePtr.ChPtr := Pointer(ChPtr);
        ModePtr.Mode := 'n';
        ModeList.Add(ModePtr);

        ModePtr := TMode.Create;
        ModePtr.ChPtr := Pointer(ChPtr);
        ModePtr.Mode := 't';
        ModeList.Add(ModePtr);

        ChDataPtr := TChannelData.Create;
        ChDataPtr.ChPtr := Pointer(ChPtr);
        ChDataPtr.CPtr := Pointer(CPtr);
        ChDataPtr.Flags := 'o';
        ChannelDataList.Add(ChDataPtr);
        Thread.Connection.WriteLn(Format(':%s!%s@%s JOIN :%s', [CPtr.Name, CPtr.UserName, CPtr.Host, Channel[CountChans]]));
        for Count := 0 to ModeList.Count - 1 do
        begin
          if ChPtr = Pointer(TMode(ModeList.Items[Count]).ChPtr) then
            if length(ModeTmp) = 0 then
              ModeTmp := '+'+TMode(ModeList.Items[Count]).Mode
            else
              ModeTmp := ModeTmp+TMode(ModeList.Items[Count]).Mode;
        end;

        WriteCl(Thread, Format('MODE %s %s', [ChPtr.Name, ModeTmp]));

        ModeTmp := '';

        ircdCommandNames(Thread, Channel[CountChans]);
        Inc(ChannelsCount);
      end else
      begin
        ChPtr := Pointer(FindChannel(Channel[CountChans]));
        if HaveMode(ChPtr, 'l') <> nil then
        begin
          ModePtr := Pointer(HaveMode(ChPtr, 'l'));
          for Count := 0 to ChannelDataList.Count - 1 do
            if (ChPtr = Pointer(TChannelData(ChannelDataList.Items[Count]).ChPtr)) then
              Inc(CountTotal);

          if CountTotal = ModePtr.Limit then
          begin
            WriteCl(Thread, Format('%d %s '+MSG_CHANNELISFULL, [ERR_CHANNELISFULL, CPtr.Name, ChPtr.Name]));
            Exit;
          end;
        end;
        if HaveMode(ChPtr, 'k') <> nil then
        begin
          ModePtr := Pointer(HaveMode(ChPtr, 'k'));
          ModeTmp := Fetch(Parm2, ' ');
          if ModePtr.Key <> ModeTmp then
          begin
            WriteCl(Thread, Format('%d %s '+MSG_BADCHANNELKEY, [ERR_BADCHANNELKEY, CPtr.Name, ChPtr.Name]));
            Exit;
          end;
        end;

        if (HaveMode(ChPtr, 'i') <> nil) and (FindInvite(ChPtr, CPtr) = nil) then
        begin
          WriteCl(Thread, Format('%d %s '+MSG_INVITEONLYCHAN, [ERR_INVITEONLYCHAN, CPtr.Name, ChPtr.Name]));
          Exit;
        end;

        if (FindBan(ChPtr, True, Format('%s!%s@%s', [CPtr.Name, CPtr.UserName, CPtr.Host])) <> nil) then
        begin
          WriteCl(Thread, Format('%d %s '+MSG_BANNEDFROMCHAN, [ERR_BANNEDFROMCHAN, CPtr.Name, ChPtr.Name]));
          Exit;
        end;


        ChDataPtr := TChannelData.Create;
        ChDataPtr.ChPtr := Pointer(ChPtr);
        ChDataPtr.CPtr := Pointer(CPtr);
        ChDataPtr.Flags := '';
        ChannelDataList.Add(ChDataPtr);
        Thread.Connection.WriteLn(Format(':%s!%s@%s JOIN :%s', [CPtr.Name, CPtr.UserName, CPtr.Host, Channel[CountChans]]));

        for Count := 0 to ModeList.Count - 1 do
        begin
          if ChPtr = Pointer(TMode(ModeList.Items[Count]).ChPtr) then
            if length(ModeTmp) = 0 then
              ModeTmp := '+'+TMode(ModeList.Items[Count]).Mode
            else
              ModeTmp := ModeTmp+TMode(ModeList.Items[Count]).Mode;
        end;

        WriteCl(Thread, Format('%d %s %s', [RPL_CHANNELMODEIS, CPtr.Name, Format(MSG_CHANNELMODEIS, [ChPtr.Name, ModeTmp, ''])]));

        ircdCommandTopic(Thread, Channel[CountChans], '');

        ircdCommandNames(Thread, Channel[CountChans]);

        for Count := 0 to ChannelDataList.Count - 1 do
        begin
           AChPtr := Pointer(TChannelData(ChannelDataList.Items[Count]).ChPtr);
           if AChPtr = ChPtr then
           begin
           ACPtr := Pointer(TChannelData(ChannelDataList.Items[Count]).CPtr);
             if CPtr <> ACPtr then
             begin
               AThread := ACPtr.Thread;
               AThread.Connection.WriteLn(Format(':%s!%s@%s JOIN :%s', [CPtr.Name, CPtr.UserName, CPtr.Host, Channel[CountChans]]));
             end;
           end;
        end;
      end;
    end;
  end;

  Channel.Free;
  ChannelKey.Free;

end;

procedure TPRJFPrincipal.ircdCommandNames(Thread: TIdPeerThread;
  Parm: String);
var
  CPtr,
  TempCPtr      : TClient;
  ChPtr         : TChannel;
  NicksTemp,
  NickTemp     : String;
  NickCounter,
  Count     : Integer;
begin
  if not IsRegistered(Thread) then
  begin
    NotRegistered(Thread);
    exit;
  end;

  CPtr := Pointer(Thread.Data);

  ChPtr := Pointer(FindChannel(Parm));

  NickCounter := 0;

  for Count := 0 to ChannelDataList.Count - 1 do
    if TChannelData(ChannelDataList.Items[Count]).ChPtr = Pointer(ChPtr) then
    begin
      Inc(NickCounter);

      TempCPtr := Pointer(TChannelData(ChannelDataList.Items[Count]).CPtr);

      if Pos('v',TChannelData(ChannelDataList.Items[Count]).Flags) <> 0 then
        NickTemp := '+';

      if Pos('o',TChannelData(ChannelDataList.Items[Count]).Flags) <> 0 then
        NickTemp := '@';

      NickTemp := NickTemp+TempCPtr.Name;

      if (NickCounter = 1) then
        NicksTemp := NickTemp
      else
        NicksTemp := NicksTemp+' '+NickTemp;

      NickTemp := '';

      if ((NickCounter = 37) or (Count = ChannelDataList.Count - 1)) then begin
        WriteCl(Thread, Format('%d %s %s', [RPL_NAMREPLY, CPtr.Name, Format(MSG_NAMREPLY, [Parm, NicksTemp])]));
        NicksTemp := '';
        NickCounter := 0;
      end;
    end;

  WriteCl(Thread, Format('%d %s %s', [RPL_ENDOFNAMES, CPtr.Name, Format(MSG_ENDOFNAMES, [Parm])]));

end;

procedure TPRJFPrincipal.ircdCommandPart(Thread: TIdPeerThread;
  Parm: String);
var
  CPtr,
  ACPtr         : TClient;
  Count,
  TotalMembers,
  CountChans,
  Count2        : Integer;
  ChPtr,
  AChPtr        : TChannel;
  Channel       : TStringList;
  AThread       : TIdPeerThread;
  ChDataPtr     : TChannelData;

label DelChanData;

begin
  if not IsRegistered(Thread) then
  begin
    NotRegistered(Thread);
    exit;
  end;

  CPtr := Pointer(Thread.Data);

  if Pos(' ',Parm) <> 0 then
    Parm := Copy(Parm,1,Pos(' ',Parm) - 1);

  Channel := TStringList.Create;

  Channel.CommaText := Parm;

  for CountChans := 0 to Channel.Count - 1 do
  begin

  if Copy(Channel[CountChans],1,1) = '#' then
  begin
    if FindChannel(Channel[CountChans]) <> nil then
    begin
      ChPtr := Pointer(FindChannel(Channel[CountChans]));
      TotalMembers := 0;

      DelChanData:
      for Count := 0 to ChannelDataList.Count - 1 do
      begin
        AChPtr := Pointer(TChannelData(ChannelDataList.Items[Count]).ChPtr);
        if ChPtr = AChPtr then
        begin
          Inc(TotalMembers);
          ChDataPtr := Pointer(TChannelData(ChannelDataList.Items[Count]));
          if CPtr = Pointer(ChDataPtr.CPtr) then
          begin
            ChannelDataList.Delete(ChannelDataList.IndexOf(ChDataPtr));
            ChDataPtr.Free;
            goto DelChanData;
          end;
        end;
      end;

      Thread.Connection.WriteLn(Format(':%s!%s@%s PART %s', [CPtr.Name, CPtr.UserName, CPtr.Host, Channel[CountChans]]));

      if TotalMembers = 1 then
      begin
        FreeChan(ChPtr);

        ChannelList.Delete(ChannelList.IndexOf(ChPtr));
        ChPtr.Free;
        Dec(ChannelsCount);
      end else begin

        for Count2 := 0 to ChannelDataList.Count - 1 do
        begin
           AChPtr := Pointer(TChannelData(ChannelDataList.Items[Count2]).ChPtr);
           if AChPtr = ChPtr then
           begin
             ACPtr := Pointer(TChannelData(ChannelDataList.Items[Count2]).CPtr);
             if CPtr.Name <> ACPtr.Name then
             begin
               AThread := ACPtr.Thread;
               AThread.Connection.WriteLn(Format(':%s!%s@%s PART %s', [CPtr.Name, CPtr.UserName, CPtr.Host, Channel[CountChans]]));
             end;
           end;
        end;

      end;

    end else
    begin
      WriteCl(Thread, Format('%d %s %s', [ERR_NOSUCHCHANNEL, CPtr.Name, Format(MSG_NOSUCHCHANNEL, [Channel[CountChans]])]));
    end;
  end else
  begin
    WriteCl(Thread, Format('%d %s %s', [ERR_NOSUCHCHANNEL, CPtr.Name, Format(MSG_NOSUCHCHANNEL, [Channel[CountChans]])]));
  end;
  end;

  Channel.Free;

end;

procedure TPRJFPrincipal.ircdCommandList(Thread: TIdPeerThread; Parm1,
  Parm2: String);
var
  CPtr : TClient;
  Count,
  Count2,
  TotalMembers : Integer;
  ChanPtr : TChannel;
begin
  if not IsRegistered(Thread) then
  begin
    NotRegistered(Thread);
    exit;
  end;

  CPtr := Pointer(Thread.Data);

  WriteCl(Thread, Format('%d %s %s', [RPL_LISTSTART, CPtr.Name, MSG_LISTSTART]));

  for Count := 0 to ChannelList.Count - 1 do
  begin
    ChanPtr := Pointer(TChannel(ChannelList.Items[Count]));
    if HaveMode(ChanPtr, 's') <> nil then
      Continue;
    if (Length(Parm1) <> 0) and (Copy(Parm1,1,1) = '#') then
      if not Matches(Copy(ChanPtr.Name,2,Length(ChanPtr.Name)),Copy(Parm1,2,Length(Parm1))) then
        Continue;
    TotalMembers := 0;
    for Count2 := 0 to ChannelDataList.Count - 1 do
      if ChanPtr = Pointer(TChannelData(ChannelDataList.Items[Count2]).ChPtr) then
        Inc(TotalMembers);
    WriteCl(Thread, Format('%d %s %s %d :%s', [RPL_LIST, CPtr.Name, ChanPtr.Name, TotalMembers, ChanPtr.Topic]));
  end;

  WriteCl(Thread, Format('%d %s %s', [RPL_LISTEND, CPtr.Name, MSG_LISTEND]));

end;

procedure TPRJFPrincipal.ircdCommandMode(Thread: TIdPeerThread; Parm1,
  Parm2, Parm3, Parm4, Parm5: String);
var
  CPtr,
  ACptr         : TClient;
  ChPtr         : TChannel;
  ModePtr       : TMode;
  Count,
  Count2,
  TotalModes    : Integer;
  ModeTemp,
  ModeTemp2,
  Wath,
  ModeSuccess,
  ModeSuccessParm   : String;
  ChDataPtr     : TChannelData;
  BanPtr        : TBan;

  function IncMode(Modes, Wath, Mode: String): String;
  var
    AWath : String;
    Count : Integer;
  begin
    if Modes = '' then
      Result := Wath+Mode;

    for Count := 1 to Length(Modes) do
      if (Modes[Count] = '+') or (Modes[Count] = '-') then
        AWath := Modes[Count];
    if AWath <> Wath then
      Result := Modes+Wath+Mode
    else
      Result := Modes+Mode;
  end;

  function ClearMasks(Mask: String): String;
  var
    Parm1,
    Parm2,
    Parm3      :String;
  begin
    while (Pos('**',Mask) <> 0) do
      Mask := StringReplace(Mask, '**', '*', [rfreplaceall]);

    if (Pos('!',Mask) = 0) and (Pos('@',Mask) = 0) then
      Result := Mask+'!*@*';

    if (Pos('!',Mask) <> 0) and (Pos('@',Mask) = 0) then
    begin
      if Length(Mask) = 1 then
        Result := '*!*@*';
      if (Pos('!',Mask) = Length(Mask)) then
        Result := Mask+'*@*';
      if (Pos('!',Mask) = 1) then
        Result := '*'+Mask+'@*';
    end;

    if (Pos('@',Mask) <> 0) and (Pos('!',Mask) = 0) then
    begin
      if Length(Mask) = 1 then
        Result := '*!*@*';
      if (Pos('@',Mask) = Length(Mask)) then
        Result := '*!'+Mask+'*';
      if (Pos('@',Mask) = 1) then
        Result := '*!*'+Mask;
      Result := Mask+'@*'
    end;

    if (Pos('@',Mask) <> 0) and (Pos('!',Mask) = 0) then
    begin
      if Length(Mask) = 1 then
        Result := '*!*@*';
      if (Pos('@',Mask) = Length(Mask)) then
        Result := '*!'+Mask+'*';
      if (Pos('@',Mask) = 1) then
        Result := '*!*'+Mask;
      Result := '*!'+Mask;
    end;

    if (Pos('!',Mask) <> 0) and (Pos('@',Mask) <> 0) then
    begin
      if Length(Mask) = 2 then
        Result := '*!*@*';
      if (Pos('!',Mask) > Pos('@',Mask)) then
        Result := Mask+'!*@*';
      if (Pos('@',Mask) = Length(Mask)) then
        Result := Copy(Mask,1,Pos('!',Mask))+'*@*';
      if (Pos('!',Mask) = Length(Mask)) then
        Result := Mask+'*@*';
      Result := Mask;
    end;

//    Result := Name+'!'+UserName+'@'+Host;
  end;
{
MODE de usuario
:aisudhuaisdhiu MODE aisudhuaisdhiu :+p
}
begin
  if not IsRegistered(Thread) then
  begin
    NotRegistered(Thread);
    exit;
  end;

  CPtr := Pointer(Thread.Data);

  if (FindChannel(Parm1) <> nil) then
  begin
    ChPtr := Pointer(FindChannel(Parm1));

    if (Length(Parm2) = 0) then
    begin
      for Count := 0 to ModeList.Count - 1 do
      begin
        ModePtr := Pointer(TMode(ModeList.Items[Count]));
        if ChPtr = Pointer(ModePtr.ChPtr) then
        begin
          ModeTemp := ModeTemp+ModePtr.Mode;

          if ModePtr.Mode = 'k' then
            if ModeTemp2 = '' then
              ModeTemp2 := ModePtr.Key
            else
              ModeTemp2 := ModeTemp2+' '+ModePtr.Key;
          if ModePtr.Mode = 'l' then
            if ModeTemp2 = '' then
              ModeTemp2 := IntToStr(ModePtr.Limit)
            else
              ModeTemp2 := ModeTemp2+' '+IntToStr(ModePtr.Limit);
        end;
      end;
      WriteCl(Thread, Format('%d %s %s', [RPL_CHANNELMODEIS, CPtr.Name, Format(MSG_CHANNELMODEIS, [ChPtr.Name, '+'+ModeTemp, ModeTemp2]) ]));
      WriteCl(Thread, Format('%d %s %s', [RPL_CHANNELCREATE, CPtr.Name, Format(MSG_CHANNELCREATE, [ChPtr.Name, 0]) ]));
    end else begin

    if not IsOnChannel(CPtr, ChPtr) then
    begin
      WriteCl(Thread, Format('%d %s %s', [ERR_NOTONCHANNEL, CPtr.Name, Format(MSG_NOTONCHANNEL, [ChPtr.Name])]));
      Exit;
    end;

    if not IsOp(CPtr, ChPtr) then
    begin
      if (Parm2 <> '+b') then
      begin
        WriteCl(Thread, Format('%d %s %s', [ERR_CHANOPRIVSNEEDED, CPtr.Name, Format(MSG_CHANOPRIVSNEEDED, [ChPtr.Name])]));
        Exit;
      end else
      begin
        if (Parm3 <> '') then
        begin
          WriteCl(Thread, Format('%d %s %s', [ERR_CHANOPRIVSNEEDED, CPtr.Name, Format(MSG_CHANOPRIVSNEEDED, [ChPtr.Name])]));
          Exit;
        end;
      end;
    end;


    for Count := 1 to Length(Parm2) do
    begin
      if (Parm2[Count] <> '+') and (Parm2[Count] <> '-') then
        if not ValidMode(Parm2[Count]) then
        begin
          WriteCl(Thread, Format('%d %s %s', [ERR_UNKNOWNMODE, CPtr.Name, Format(MSG_UNKNOWNMODE, [Parm2[Count]])]));
          Exit;
        end
      else
        Continue;
    end;

    Wath := '';

    ModeSuccess := '';
    ModeSuccessParm := '';

    TotalModes := 0;

    if Parm4 <> '' then
      Parm3 := Parm3+' '+Parm4;
    if Parm5 <> '' then
      Parm3 := Parm4+' '+Parm5;

    for Count := 1 to Length(Parm2) do
    begin
      if (Parm2[Count] = '+') or (Parm2[Count] = '-') then
      begin
        Wath := Parm2[Count];
        Continue;
      end;

      if (Wath = '') then Continue;

      Inc(TotalModes);

      Case Succ ( PosInStrArray ( Parm2[Count] , chan_modes ) ) of
        1 : begin {b}
          ModeTemp := Copy(Fetch(Parm3, ' '),1,NICKLEN);

          if ModeTemp <> '' then
            ModeTemp := ClearMasks(ModeTemp);

          if Wath = '+' then
          begin
            if (Length(Parm2) = 2) and (ModeTemp = '') then
            begin
              for Count2 := 0 to BanList.Count - 1 do
                if (ChPtr = Pointer(TBan(BanList.Items[Count2]).ChPtr)) then
                begin
                  BanPtr := Pointer(TBan(BanList.Items[Count2]));
                  WriteCl(Thread, Format('%d %s '+MSG_BANLIST, [RPL_BANLIST, CPtr.Name, ChPtr.Name, BanPtr.BanStr, BanPtr.Who, 0]));
                end;
              WriteCl(Thread, Format('%d %s '+MSG_ENDOFBANLIST, [RPL_ENDOFBANLIST, CPtr.Name, ChPtr.Name]));
            end else
            begin
              if FindBan(ChPtr, False, ModeTemp) = nil then
              begin
                BanPtr := TBan.Create;
                BanPtr.BanStr := ModeTemp;
                BanPtr.ChPtr := Pointer(ChPtr);
                BanPtr.Who := Format('%s!%s@%s', [CPtr.Name, CPtr.UserName, CPtr.Host]);
                BanList.Add(BanPtr);
                ModeSuccess := IncMode(ModeSuccess,Wath,'b');
                if (ModeSuccessParm = '') then
                  ModeSuccessParm := BanPtr.BanStr
                else
                  ModeSuccessParm := ModeSuccessParm+' '+BanPtr.BanStr;
              end;
            end;
          end else
          begin
            if FindBan(ChPtr, False, ModeTemp) <> nil then
            begin
              BanPtr := FindBan(ChPtr, False, ModeTemp);
              if (ModeSuccessParm = '') then
                ModeSuccessParm := BanPtr.BanStr
              else
                ModeSuccessParm := ModeSuccessParm+' '+BanPtr.BanStr;
              BanList.Delete(BanList.IndexOf(BanPtr));
              BanPtr.Free;
              ModeSuccess := IncMode(ModeSuccess,Wath,'b');
            end;
          end;
        end;
        2 : begin {i}
          if Wath = '+' then
          begin
            if HaveMode(ChPtr, 'i') = nil then
            begin
              ModePtr := TMode.Create;
              ModePtr.ChPtr := Pointer(ChPtr);
              ModePtr.Mode := 'i';
              ModeList.Add(Pointer(ModePtr));
              ModeSuccess := IncMode(ModeSuccess,Wath,'i');
            end;
          end else
          begin
            if HaveMode(ChPtr, 'i') <> nil then
            begin
              ModePtr := Pointer(HaveMode(ChPtr, 'i'));
              ModeList.Delete(ModeList.IndexOf(Pointer(ModePtr)));
              ModePtr.Free;
              ModeSuccess := IncMode(ModeSuccess,Wath,'i');
            end;
          end;
        end;
        3 : begin {k}
          ModeTemp := Copy(Fetch(Parm3, ' '),1,KEYLEN);
          if Wath = '+' then
          begin
            if HaveMode(ChPtr, 'k') <> nil then
            begin
              ModePtr := Pointer(HaveMode(ChPtr, 'k'));
              ModePtr.Key := ModeTemp;
              ModeSuccess := IncMode(ModeSuccess,Wath,'k');
              if (ModeSuccessParm = '') then
                ModeSuccessParm := ModePtr.Key
              else
                ModeSuccessParm := ModeSuccessParm+' '+ModePtr.Key;
            end
            else begin
              ModePtr := TMode.Create;
              ModePtr.ChPtr := Pointer(ChPtr);
              ModePtr.Mode := 'k';
              ModePtr.Key := ModeTemp;
              ModeList.Add(Pointer(ModePtr));
              ModeSuccess := IncMode(ModeSuccess,Wath,'k');
              if (ModeSuccessParm = '') then
                ModeSuccessParm := ModePtr.Key
              else
                ModeSuccessParm := ModeSuccessParm+' '+ModePtr.Key;
            end;
          end else
          begin
            if HaveMode(ChPtr, 'k') <> nil then
            begin
              ModePtr := Pointer(HaveMode(ChPtr, 'k'));
              if (ModeSuccessParm = '') then
                ModeSuccessParm := ModePtr.Key
              else
                ModeSuccessParm := ModeSuccessParm+' '+ModePtr.Key;
              ModeList.Delete(ModeList.IndexOf(Pointer(ModePtr)));
              ModePtr.Free;
              ModeSuccess := IncMode(ModeSuccess,Wath,'k');
            end;
          end;
        end;
        4 : begin {l}
          ModeTemp := Copy(Fetch(Parm3, ' '),1,KEYLEN);

          if (Wath = '+') then
            try
              StrToInt(ModeTemp)
            except
              on EConvertError do Continue;
            end;

          if Wath = '+' then
          begin;
            if HaveMode(ChPtr, 'l') <> nil then
            begin
              ModePtr := Pointer(HaveMode(ChPtr, 'l'));
              ModePtr.Limit := StrToInt(ModeTemp);
              ModeSuccess := IncMode(ModeSuccess,Wath,'l');
              if (ModeSuccessParm = '') then
                ModeSuccessParm := ModeTemp
              else
                ModeSuccessParm := ModeSuccessParm+' '+ModeTemp;
            end
            else begin
              ModePtr := TMode.Create;
              ModePtr.ChPtr := Pointer(ChPtr);
              ModePtr.Mode := 'l';
              ModePtr.Limit := StrToInt(ModeTemp);
              ModeList.Add(Pointer(ModePtr));
              ModeSuccess := IncMode(ModeSuccess,Wath,'l');
              if (ModeSuccessParm = '') then
                ModeSuccessParm := ModeTemp
              else
                ModeSuccessParm := ModeSuccessParm+' '+ModeTemp;
            end;
          end else
          begin
            if HaveMode(ChPtr, 'l') <> nil then
            begin
              ModePtr := Pointer(HaveMode(ChPtr, 'l'));
              if (ModeSuccessParm = '') then
                ModeSuccessParm := IntToStr(ModePtr.Limit)
              else
                ModeSuccessParm := ModeSuccessParm+' '+IntToStr(ModePtr.Limit);
              ModeList.Delete(ModeList.IndexOf(Pointer(ModePtr)));
              ModePtr.Free;
              ModeSuccess := IncMode(ModeSuccess,Wath,'l');
            end;
          end;
         end;
         5 : begin {m}
          if Wath = '+' then
          begin
            if HaveMode(ChPtr, 'm') = nil then
            begin
              ModePtr := TMode.Create;
              ModePtr.ChPtr := Pointer(ChPtr);
              ModePtr.Mode := 'm';
              ModeList.Add(Pointer(ModePtr));
              ModeSuccess := IncMode(ModeSuccess,Wath,'m');
            end;
          end else
          begin
            if HaveMode(ChPtr, 'm') <> nil then
            begin
              ModePtr := Pointer(HaveMode(ChPtr, 'm'));
              ModeList.Delete(ModeList.IndexOf(Pointer(ModePtr)));
              ModePtr.Free;
              ModeSuccess := IncMode(ModeSuccess,Wath,'m');
            end;
          end;
          end;
          6 : begin {n}
          if Wath = '+' then
          begin
            if HaveMode(ChPtr, 'n') = nil then
            begin
              ModePtr := TMode.Create;
              ModePtr.ChPtr := Pointer(ChPtr);
              ModePtr.Mode := 'n';
              ModeList.Add(Pointer(ModePtr));
              ModeSuccess := IncMode(ModeSuccess,Wath,'n');
            end;
          end else
          begin
            if HaveMode(ChPtr, 'n') <> nil then
            begin
              ModePtr := Pointer(HaveMode(ChPtr, 'n'));
              ModeList.Delete(ModeList.IndexOf(Pointer(ModePtr)));
              ModePtr.Free;
              ModeSuccess := IncMode(ModeSuccess,Wath,'n');
            end;
          end;
        end;
        7 : begin {o}
          ModeTemp := Copy(Fetch(Parm3, ' '),1,NICKLEN);

          if (FindClient(ModeTemp) = nil) then
            Continue;

          ACPtr := Pointer(FindClient(ModeTemp));

          if not IsOnChannel(ACPtr, ChPtr) then
            Continue;

          if Wath = '+' then
          begin
            if not IsOp(ACPtr, ChPtr) then
            begin
              ChDataPtr := FindChannelData(ChPtr, ACPtr);
              ChDataPtr.Flags := ChDataPtr.Flags+'o';
              ModeSuccess := IncMode(ModeSuccess,Wath,'o');
              if (ModeSuccessParm = '') then
                ModeSuccessParm := ModeTemp
              else
                ModeSuccessParm := ModeSuccessParm+' '+ModeTemp;
            end;
          end else
          begin
            if IsOp(ACPtr, ChPtr) then
            begin
              ChDataPtr := FindChannelData(ChPtr, ACPtr);
              ChDataPtr.Flags := StringReplace(ChDataPtr.Flags, 'o', '', [rfreplaceall]);
              ModeSuccess := IncMode(ModeSuccess,Wath,'o');
              if (ModeSuccessParm = '') then
                ModeSuccessParm := ModeTemp
              else
                ModeSuccessParm := ModeSuccessParm+' '+ModeTemp;
            end;
          end;
        end;
        8 : begin {p}
          if Wath = '+' then
          begin
            if HaveMode(ChPtr, 'p') = nil then
            begin
              ModePtr := TMode.Create;
              ModePtr.ChPtr := Pointer(ChPtr);
              ModePtr.Mode := 'p';
              ModeList.Add(Pointer(ModePtr));
              ModeSuccess := IncMode(ModeSuccess,Wath,'p');
            end
          end else
          begin
            if HaveMode(ChPtr, 'p') <> nil then
            begin
              ModePtr := Pointer(HaveMode(ChPtr, 'p'));
              ModeList.Delete(ModeList.IndexOf(Pointer(ModePtr)));
              ModePtr.Free;
              ModeSuccess := IncMode(ModeSuccess,Wath,'p');
            end;
          end;
        end;
        9 : begin {s}
          if Wath = '+' then
          begin
            if HaveMode(ChPtr, 's') = nil then
            begin
              ModePtr := TMode.Create;
              ModePtr.ChPtr := Pointer(ChPtr);
              ModePtr.Mode := 's';
              ModeList.Add(Pointer(ModePtr));
              ModeSuccess := IncMode(ModeSuccess,Wath,'s');
            end;
          end else
          begin
            if HaveMode(ChPtr, 's') <> nil then
            begin
              ModePtr := Pointer(HaveMode(ChPtr, 's'));
              ModeList.Delete(ModeList.IndexOf(Pointer(ModePtr)));
              ModePtr.Free;
              ModeSuccess := IncMode(ModeSuccess,Wath,'s');
            end;
          end;
         end;
        10 : begin {t}
          if Wath = '+' then
          begin
            if HaveMode(ChPtr, 't') = nil then
            begin
              ModePtr := TMode.Create;
              ModePtr.ChPtr := Pointer(ChPtr);
              ModePtr.Mode := 't';
              ModeList.Add(Pointer(ModePtr));
              ModeSuccess := IncMode(ModeSuccess,Wath,'t');
            end;
          end else
          begin
            if HaveMode(ChPtr, 't') <> nil then
            begin
              ModePtr := Pointer(HaveMode(ChPtr, 't'));
              ModeList.Delete(ModeList.IndexOf(Pointer(ModePtr)));
              ModePtr.Free;
              ModeSuccess := IncMode(ModeSuccess,Wath,'t');
            end;
          end;
        end;
        11 : begin {v}
          ModeTemp := Copy(Fetch(Parm3, ' '),1,NICKLEN);

          if (FindClient(ModeTemp) = nil) then
            Continue;

          ACPtr := Pointer(FindClient(ModeTemp));

          if not IsOnChannel(ACPtr, ChPtr) then
            Continue;

          if Wath = '+' then
          begin
            if not IsVoice(ACPtr, ChPtr) then
            begin
              ChDataPtr := FindChannelData(ChPtr, ACPtr);
              ChDataPtr.Flags := ChDataPtr.Flags+'v';
              ModeSuccess := IncMode(ModeSuccess,Wath,'v');
              if (ModeSuccessParm = '') then
                ModeSuccessParm := ModeTemp
              else
                ModeSuccessParm := ModeSuccessParm+' '+ModeTemp;
            end;
          end else
          begin
            if IsVoice(ACPtr, ChPtr) then
            begin
              ChDataPtr := FindChannelData(ChPtr, ACPtr);
              ChDataPtr.Flags := StringReplace(ChDataPtr.Flags, 'v', '', [rfreplaceall]);
              ModeSuccess := IncMode(ModeSuccess,Wath,'v');
              if (ModeSuccessParm = '') then
                ModeSuccessParm := ModeTemp
              else
                ModeSuccessParm := ModeSuccessParm+' '+ModeTemp;
            end;
          end;
        end;

      end;

      if TotalModes = 6 then
        Break;

    end;

    if ModeSuccessParm <> '' then
      ModeSuccess := ModeSuccess+' '+ModeSuccessParm;

    if ModeSuccess <> '' then
      SendToChannel(ChPtr, Format(':%s!%s@%s MODE %s %s', [CPtr.Name, CPtr.UserName, CPtr.Host, ChPtr.Name, ModeSuccess]));

  end;

  end else if (FindClient(Parm1) <> nil) then
  begin
    if CPtr = Pointer(FindClient(Parm1)) then
    begin

      if (Length(Parm2) = 0) then
      begin
        for Count := 0 to ModeList.Count - 1 do
        begin
          ModePtr := Pointer(TMode(ModeList.Items[Count]));
          if CPtr = Pointer(ModePtr.CPtr) then
          begin
            if ModeTemp = '' then
              ModeTemp := ModePtr.Mode
            else
              ModeTemp := ModeTemp+' '+ModePtr.Mode;

           end;
        end;
        WriteCl(Thread, Format('%d %s %s', [RPL_UMODEIS, Format(MSG_UMODEIS, [CPtr.Name, ModeTemp]) ]));
      end;

    end else
      WriteCl(Thread, Format('%d %s %s', [ERR_USERSDONTMATCH, CPtr.Name, MSG_USERSDONTMATCH]));

  end else
    WriteCl(Thread, Format('%d %s %s', [ERR_NOSUCHNICK, CPtr.Name, Format(MSG_NOSUCHNICK, [Parm1])]));

end;

procedure TPRJFPrincipal.ircdCommandPing(Thread: TIdPeerThread; Parm1,
  Parm2: String);
begin
  WriteCl(Thread, Format('PONG %s :%s', [MENAME, Parm1]));
end;

procedure TPRJFPrincipal.ircdCommandNotice(Thread: TIdPeerThread; Parm1,
  Parm2: String);
begin
  PrivNotice(Thread, 'NOTICE', Parm1, Parm2);
end;

procedure TPRJFPrincipal.ircdException(AThread: TIdPeerThread;
  AException: Exception);
var
  CPtr : TClient;
begin

  ShowInfo('Exception '+AException.Message);

  if (Pos('Socket Error',AException.Message) <> 0) or (Pos('Connection Closed',AException.Message) <> 0) then
  begin
    CPtr := Pointer(AThread.Data);
    SendToCommomChannels(AThread, Format(':%s!%s@%s QUIT :%s', [CPtr.Name, CPtr.UserName, CPtr.Host, AException.Message]));
  end;

end;

procedure TPRJFPrincipal.ircdCommandTopic(Thread: TIdPeerThread; Parm1,
  Parm2: String);
var
  CPtr          : TClient;
  ChPtr         : TChannel;
begin
  if not IsRegistered(Thread) then
  begin
    NotRegistered(Thread);
    exit;
  end;

  CPtr := Pointer(Thread.Data);

  if (Copy(Parm1,1,1) <> '#') then
    Exit;

  if (FindChannel(Parm1) <> nil) then
  begin
    ChPtr := Pointer(FindChannel(Parm1));
    if IsOnChannel(CPtr,ChPtr) then
    begin
      if Length(Parm2) = 0 then
      begin
        if Length(ChPtr.Topic) = 0 then
        begin
          WriteCl(Thread, Format('%d %s '+MSG_NOTOPIC, [RPL_NOTOPIC, CPtr.Name, ChPtr.Name]));
        end else
        begin
          WriteCl(Thread, Format('%d %s %s', [RPL_TOPIC, CPtr.Name, Format(MSG_TOPIC, [ChPtr.Name, ChPtr.Topic])]));
          WriteCl(Thread, Format('%d %s %s', [RPL_TOPICTIME, CPtr.Name, Format(MSG_TOPICTIME, [ChPtr.Name, ChPtr.TopicNick, 0] )]));
        end;
      end else
      begin
        if HaveMode(ChPtr, 'n') <> nil then
          if IsOp(CPtr,ChPtr) then
          begin
            ChPtr.Topic := Copy(Parm2,2,Length(Parm2));
            ChPtr.TopicNick := CPtr.Name;
            SendToChannel(ChPtr, Format(':%s!%s@%s TOPIC %s %s', [CPtr.Name, CPtr.UserName, CPtr.Host, ChPtr.Name, Parm2]));
          end else
            WriteCl(Thread, Format('%d %s %s', [ERR_CHANOPRIVSNEEDED, CPtr.Name, Format(MSG_CHANOPRIVSNEEDED, [ChPtr.Name])]))
        else
        begin
            ChPtr.Topic := Copy(Parm2,2,Length(Parm2));
            ChPtr.TopicNick := CPtr.Name;
            SendToChannel(ChPtr, Format(':%s!%s@%s TOPIC %s %s', [CPtr.Name, CPtr.UserName, CPtr.Host, ChPtr.Name, Parm2]));
        end;

      end;
    end else
      WriteCl(Thread, Format('%d %s %s', [ERR_NOTONCHANNEL, CPtr.Name, Format(MSG_NOTONCHANNEL, [ChPtr.Name])]));
  end;

end;

procedure TPRJFPrincipal.ircdCommandInvite(Thread: TIdPeerThread; Parm1,
  Parm2: String);
//Parm1 = nick
//Parm2 = canal
var
  CPtr,
  ACPtr : TClient;
  InvPtr : TInvite;
  AChPtr : TChannel;
  AThread : TIdPeerThread;
begin
  if not IsRegistered(Thread) then
  begin
    NotRegistered(Thread);
    exit;
  end;

  CPtr := Pointer(Thread.Data);

  if Length(Parm2) = 0 then
  begin
    WriteCl(Thread, Format('%d %s '+MSG_NEEDMOREPARAMS, [ERR_NEEDMOREPARAMS, CPtr.Name, 'INVITE']));
    Exit;
  End;

  if (FindClient(Parm1) = nil) then
  begin
    WriteCl(Thread, Format('%d %s '+MSG_NOSUCHNICK, [ERR_NOSUCHNICK, CPtr.Name, Parm1]));
    Exit;
  End;

  if (FindChannel(Parm2) = nil) then
  begin
    WriteCl(Thread, Format('%d %s '+MSG_NOSUCHCHANNEL, [ERR_NOSUCHCHANNEL, CPtr.Name, Parm2]));
    Exit;
  End;

  if not IsOnChannel(CPtr, Pointer(FindChannel(Parm2))) then
  begin
    WriteCl(Thread, Format('%d %s '+MSG_NOTONCHANNEL, [ERR_NOTONCHANNEL, CPtr.Name, Parm2]));
    Exit;
  End;

  ACPtr := Pointer(FindClient(Parm1));
  AChPtr := Pointer(FindChannel(Parm2));

  if IsOnChannel(ACptr, AChPtr) then
  begin
    WriteCl(Thread, Format('%d %s '+MSG_USERONCHANNEL, [ERR_USERONCHANNEL, CPtr.Name, Parm1, Parm2]));
    Exit;
  End;

  if FindInvite(AChPtr, ACPtr) = nil then
  begin
    InvPtr := TInvite.Create;
    InvPtr.ChPtr := Pointer(AChPtr);
    InvPtr.CPtr := Pointer(ACPtr);
    InviteList.Add(InvPtr);
  end;

  WriteCl(Thread, Format('%d %s '+MSG_INVITING, [RPL_INVITING, CPtr.Name, ACPtr.Name, AChPtr.Name]));
  AThread := ACPtr.Thread;
  AThread.Connection.WriteLn(Format(':%s!%s@%S INVITE %s :%s', [CPtr.Name, CPtr.UserName, CPtr.Host, ACPtr.Name, AChPtr.Name]));


end;

procedure TPRJFPrincipal.ircdCommandKick(Thread: TIdPeerThread; Parm1,
  Parm2, Parm3: String);
var
  CPtr,
  ACPtr     : TClient;
  ChPtr     : TChannel;
  ChDataPtr : TChannelData;
  Count,
  TotalMembers : Integer;

begin
  if not IsRegistered(Thread) then
  begin
    NotRegistered(Thread);
    exit;
  end;

  CPtr := Pointer(Thread.Data);

  if (FindClient(Parm2) = nil) then
  begin
    WriteCl(Thread, Format('%d %s '+MSG_NOSUCHNICK, [ERR_NOSUCHNICK, CPtr.Name, Parm2]));
    Exit;
  End;

  if (FindChannel(Parm1) = nil) then
  begin
    WriteCl(Thread, Format('%d %s '+MSG_NOSUCHCHANNEL, [ERR_NOSUCHCHANNEL, CPtr.Name, Parm1]));
    Exit;
  End;

  if not IsOnChannel(CPtr, Pointer(FindChannel(Parm1))) then
  begin
    WriteCl(Thread, Format('%d %s '+MSG_NOTONCHANNEL, [ERR_NOTONCHANNEL, CPtr.Name, Parm1]));
    Exit;
  End;

  ACPtr := Pointer(FindClient(Parm2));
  ChPtr := Pointer(FindChannel(Parm1));

  if not IsOp(CPtr, ChPtr) then
  begin
    WriteCl(Thread, Format('%d %s '+MSG_CHANOPRIVSNEEDED, [ERR_CHANOPRIVSNEEDED, CPtr.Name, ChPtr.Name]));
    Exit;
  end;

  if (Parm3 = '') or (Parm3 = ':') then Parm3 := ':'+CPtr.Name;

  SendToChannel(ChPtr, Format(':%s!%s@%s KICK %s %s %s', [CPtr.Name, CPtr.UserName, CPtr.Host, ChPtr.Name, ACPtr.Name, Parm3]));

  ChDataPtr := FindChannelData(ChPtr,ACPtr);

  ChannelDataList.Delete(ChannelDataList.IndexOf(ChDataPtr));
  ChDataPtr.Free;

//:zoinho!ElEtRoNiK@xLg7yX2R2lk.200.103.177.O KICK #TaRolando iuaheuiaheiu :?1t?7?DS?:? ?5said wh

  TotalMembers := 0;

  for Count := 0 to ChannelDataList.Count - 1 do
    if (ChPtr = Pointer( TChannelData(ChannelDataList.Items[Count]).ChPtr)) then
      Inc(TotalMembers);

  if TotalMembers = 0 then
  begin
    FreeChan(ChPtr);

    ChannelList.Delete(ChannelList.IndexOf(ChPtr));
    ChPtr.Free;
  end;
end;

end.
